import argparse
import logging
logging.getLogger("scapy.runtime").setLevel(logging.ERROR)
from support.HTTPS_support import *


NAMES=[
    "01net.com",
    "050\ plus",
    "0zz0.com",
    "10050.net",
    "10086.cn",
    "104.com",
    "1111.com.tw",
    "114la.com",
    "115.com",
    "118114.cn",
    "11st.co.kr",
    "123people.com",
    "1337x.org",
    "139mail",
    "15min.lt",
    "163.com",
    "17173.com",
    "17u.com",
    "20min.ch",
    "24h.com.vn",
    "24ora.com",
    "24sata.hr",
    "24ur.com",
    "2ch.net",
    "2Shared",
    "360buy.com",
    "360.cn",
    "3GPP\ LI",
    "Third\ Party\ Connect",
    "4399.com",
    "4CHAN",
    "4shared.com",
    "4TUBE",
    "51.com",
    "51.com\ BBS",
    "51.com\ Music",
    "51.com\ Posting",
    "51job.com",
    "51.la",
    "56.com",
    "58.com",
    "591.com.tw",
    "5pm\ -\ project\ management\ on\ time",
    "6alabat",
    "6play",
    "7k7k.com",
    "IEEE\ 802.1ad",
    "802.1Q\ Ethernet\ VLAN",
    "802.11",
    "91.com",
    "999.md",
    "99ACRES",
    "9game.com",
    "A.dakar",
    "AAJTAK",
    "Aastocks",
    "ABC\ Bittorrent\ client",
    "ABC.com.py",
    "ABCNews.go.com",
    "Abidjan.net",
    "Abola.pt",
    "About.com",
    "Abs.cbnnews",
    "Abv.bg",
    "Acbar",
    "AccuWeather.com",
    "ACEPROJECT",
    "Acer.com",
    "Acrobat.com",
    "Association\ Control\ Service",
    "Active\ Networks",
    "Microsoft\ ActiveSync",
    "Adaderana",
    "Advanced\ Direct\ Connect",
    "Adcash\ Advertising\ Network",
    "Addictinggames.com",
    "AddThis",
    "ADNStream.tv",
    "Adobe",
    "Adobe\ Connect",
    "Adobe\ Meeting\ Remote\ Control",
    "Adobe\ online\ office",
    "Adobe\ Update\ Manager",
    "Adrive.com",
    "Adserverplus",
    "AdultAdWorld.com",
    "AdultFriendFinder.com",
    "Advogato.org",
    "Afreeca\ TV",
    "Aftonbladet.se",
    "Agame.com",
    "Authentication\ Header",
    "AiAiGame.com",
    "Aib",
    "AICCU-TIC\ IPv6\ Tunneling",
    "Aili.com",
    "AOL\ Instant\ Messenger\ (formerly\ OSCAR)",
    "AIM\ express",
    "AIM\ Transfer",
    "Aimini.net",
    "Secure\ AIM",
    "Air\ Video",
    "AirAIM.com",
    "Aizhan.com",
    "Akamai\ Technologies\ CDN",
    "Akinator\ the\ Genie",
    "Aktuality.sk",
    "Alakhbar.info",
    "Alaraby",
    "Albawabhnews",
    "Alexa.com",
    "Alfajertv.com",
    "Alibaba.com",
    "AliExpress.com",
    "Alimama.com",
    "Alipay.com",
    "Aljarida",
    "AlJazeera.net",
    "Alkawnnews",
    "All\ Slots\ Casino",
    "Allegro.pl",
    "AllMusic.com",
    "AlloCine.fr",
    "AlManar.com",
    "Almashhad",
    "Almasryalyoum",
    "Alnilin.com",
    "Alrakoba.net",
    "Altiris",
    "Alwakeelnews.com",
    "Alwatanvoice.com",
    "Alyaoum24",
    "Amazon\ Web\ Services/Cloudfront\ CDN",
    "Amazon\ Adsytem",
    "Amazon\ Web\ Services/Cloudfront\ CDN",
    "Amazon\ Cloud\ Drive",
    "Amazon\ MP3",
    "Amazon\ Video",
    "Ambebi.ge",
    "Ameba.jp",
    "AmericanExpress.com",
    "AmieStreet.com",
    "Amjilt",
    "Ammonnews",
    "AMMYY-ADMIN",
    "AMOEBAOS",
    "Advance\ Message\ Queuing\ Protocol",
    "Angry\ Birds",
    "AnimeBW\ Bittorrent\ tracker",
    "ANIMOTO",
    "Anobii",
    "Anspress",
    "Answers.com",
    "ANts\ P2P\ client",
    "Any\ 0-hop",
    "Australia\ and\ New\ Zealand\ Banking\ Group",
    "Anzhi.com",
    "Aol",
    "Aol.On",
    "APA.az",
    "Aparat",
    "Apple\ Push\ Notification\ Service",
    "Apollo\ Domain:XEROX",
    "Apollo.lv",
    "APPChina.com",
    "Apple.com",
    "Apple\ AirPlay",
    "Apple\ Airport",
    "Apple\ AirPrint",
    "Apple\ HTTP\ Live\ Streaming",
    "Apple\ Maps",
    "Apple\ SIRI",
    "Apple\ Update",
    "AppleDaily.com.tw",
    "AppleJuice",
    "AppsFlyer",
    "AppShopper.com",
    "Apple\ App\ Store",
    "Aprod.hu\ (now\ Olx.hu)",
    "Apsalar",
    "Aqlame",
    "Arabiaweather",
    "Archive.org",
    "Ares",
    "ARGUS",
    "ARIS",
    "Armorgames",
    "Armorgames\ Game\ Play",
    "Address\ Resolution\ Protocol",
    "ASANA",
    "Asiae.co.kr",
    "AsianDVDClub.org",
    "Ask.com",
    "Ask.fm",
    "ASmallWorld.net",
    "ASProxy",
    "AppleTalk",
    "Athlinks.com",
    "Atlasinfo.info",
    "ATT.com\ (AT&T)",
    "Atwiki.jp",
    "Auction.co.kr",
    "Aufeminin.com",
    "Auone.jp",
    "Auto24",
    "AvatarsUnited.com",
    "Avaz.ba",
    "AVG.com",
    "Avg\ Update",
    "Avira\ Update",
    "Avito.ma",
    "Avito.ru",
    "Avoidr.com",
    "Avto.net",
    "AX.25\ Frames",
    "AxiFile.com",
    "Azet.sk",
    "B92.net",
    "Babelgum.com",
    "BabyCenter.com",
    "BabyHome.com.tw",
    "Babylon.com",
    "Backpackers.com.tw",
    "Badongo.com",
    "Badoo.com",
    "Baidu.com",
    "Baidu\ Games\ (youxi.baidu.com)",
    "Baidu\ Player",
    "Baike.com",
    "BalkanWeb.com",
    "Bancopopular",
    "Banglanews24.com",
    "Bankmellat.ir",
    "Baofeng.com",
    "Base\ virtual\ protocol",
    "battlenet",
    "Bazos",
    "BBC.co.uk",
    "BBC\ Player",
    "BlackBerry\ Messenger",
    "BlackBerry\ Messenger\ Audio",
    "BlackBerry\ Messenger\ Video",
    "BBN\ RCC\ Monitoring",
    "Bank\ BCA\ (bca.co.id)",
    "Bdnews24.com",
    "Beanfun.com",
    "Beatport",
    "Bebo.com",
    "Bebo\ mail",
    "beetalk",
    "Bemaniso\ Bittorrent\ tracker",
    "Berniaga.com",
    "bestsharing.com",
    "Bet365.com",
    "Border\ Gateway\ Protocol",
    "Bidorbuy.co.za",
    "BigAdda.com",
    "Bigeye",
    "Biglobe.ne.jp",
    "BigTent.com",
    "Bigupload.com",
    "Biip.no",
    "Bikhir.ma",
    "Bild.de",
    "Bing.com\ (formerly\ MSN\ Search)",
    "Biobiochile",
    "Bitcoin\ client",
    "BitDefender\ Update",
    "Bitenova\ Bittorrent\ tracker",
    "BitHQ\ Bittorrent\ tracker",
    "BitLord",
    "BitMe\ Bittorrent\ tracker",
    "BitMeTV\ Bittorrent\ tracker",
    "Background\ Intelligent\ Transfer\ Service",
    "BitSeduce\ Bittorrent\ tracker",
    "BitShock\ Bittorrent\ tracker",
    "Bitsoup\ Bittorrent\ tracker",
    "Bitstrips",
    "BitTorrent",
    "Bittorrent\ Apps",
    "Bitvaulttorrent\ Bittorrent\ tracker",
    "BitWorld\ Bittorrent\ tracker",
    "BJNP",
    "BlackBerry.com",
    "BlackBerry\ Locate",
    "BlackBerry\ OS\ Updates",
    "BlackPlanet.com",
    "BitTorrent\ Bleep\ (aka\ BitTorrent\ Chat)",
    "Blic.rs",
    "Blick.ch",
    "Blip.tv\ TV\ Series",
    "Blockbuster.com",
    "Blocket.se",
    "Blog.hu",
    "BlogDetik.com",
    "Blogfa.com",
    "Blogger.com",
    "Blogpark.jp",
    "Blogspot.com",
    "Blogster.com",
    "Blokus.fr",
    "Bloomberg.com",
    "Blubster",
    "Bluejayfilms.webs.com",
    "Bluewin.ch",
    "ISO\ Base\ Media\ File\ Format",
    "BNA",
    "BoldChat\ Live\ Chat",
    "Bolha.com",
    "Bolt.com\ -\ Bolt3.com",
    "Bomb01",
    "Bondisk.com",
    "Bonpoo.com",
    "Books.com.tw",
    "Books\ iRead",
    "BootyTape\ Bittorrent\ tracker",
    "Box.com",
    "Backroom\ SATNET\ Monitoring",
    "Brightcove",
    "BrightTALK.com",
    "Brown\ Tracker\ Bittorrent\ tracker",
    "BSS\ Application\ Part",
    "Bhutan\ Telecom\ (bt.bt)",
    "BT\ Chat\ Bittorrent\ tracker",
    "Bt.dk",
    "BT\ Wrzru\ Bittorrent\ tracker",
    "BT\ Junkie\ Bittorrent\ tracker",
    "BuddyBuddy.co.kr",
    "Bugs.co.kr",
    "Burt",
    "Businessweek.com",
    "Businessweekly.com.tw",
    "BuzzFeed.com",
    "Buzznet.com",
    "WAP\ Binary\ XML",
    "BypassThat.com",
    "Caak.mn",
    "Caisse\ d\'Allocations\ Familiales",
    "CafeMom.com",
    "Cam4.com",
    "Cameroon.info",
    "Campfire.com",
    "Campzap.com",
    "Candy\ Crush\ Saga",
    "CapitalOne.com",
    "Control\ And\ Provisioning\ of\ Wireless\ Access\ Points",
    "CARBONITE",
    "Care2.com",
    "CartoonNetwork.com",
    "CAS.sk",
    "Core-based\ trees",
    "Compression\ Control\ Protocol",
    "CCProxy",
    "VodCCTV",
    "Cdiscount.com",
    "CdM.me",
    "Cisco\ Discovery\ Protocol",
    "Cedexis",
    "Cellufun.com",
    "Central\ Torrent\ Bittorrent\ tracker",
    "Centrum.cz",
    "Centrum.sk",
    "Cross\ File\ Transfer",
    "Covert\ File\ Transfer\ Protocol",
    "CGIProxy",
    "Cisco\ Group\ Management\ Protocol",
    "Champion\ Football",
    "Channel4.com",
    "Chaos",
    "Challenge\ Handshake\ Authentication\ Protocol",
    "ChatON",
    "Chatroulette.com",
    "China-airlines.com",
    "China.com",
    "china.com.cn",
    "Chinanews.com",
    "ChinaRen.com",
    "Chinatimes.com",
    "Chinaz.com",
    "Chosun\ services",
    "Chosun\ website",
    "Chouftv",
    "Chrome\ Update",
    "Cinemageddon\ Bittorrent\ tracker",
    "Citrix\ Online",
    "Cjmall.com",
    "CK101.com",
    "Clarin.com",
    "ClasificadosOnline.com",
    "Classmates.com",
    "Rational\ ClearCase",
    "Jive",
    "Clicanoo",
    "Clickyab",
    "Clip",
    "Clip2Net.com",
    "Cloob.com",
    "CloudFlare\ CDN",
    "CloudMe.com",
    "Clubbox.co.kr",
    "Clubic.com",
    "Clumsy\ Ninja",
    "Cnet.com",
    "Cnettv.cnet.com",
    "CNN\ (Cable\ News\ Network)",
    "China\ Network\ Television",
    "cnYES.com",
    "cnzz.com",
    "Coccoc.com",
    "Cocolog-nifty.com",
    "CollegeBlender.com",
    "Comcast.com",
    "COMM",
    "CommentCaMarche.net",
    "COMP",
    "Compaq\ Peer",
    "Concur.com",
    "Conduit\ Services",
    "Conviva\ CDN",
    "CoralCDN\ user",
    "Connection\ Oriented\ Transfer\ Protocol",
    "CouchSurfing.org",
    "Coupang.com",
    "Computer\ Protocol\ Heart\ Beat",
    "Computer\ Protocol\ Network\ Executive",
    "Crackle",
    "craigslist",
    "Crashlytics",
    "Crazysaloon\ Bittorrent\ tracker",
    "Crhoy",
    "Criteo",
    "Crittercism",
    "Crnobelo.com",
    "Crocko.com\ (CROCKOTEC)",
    "Combat\ Radio\ Transport\ Protocol",
    "Combat\ Radio\ User\ Datagram",
    "CryptoHeaven.com",
    "Crystalbet",
    "Chinese\ Software\ Developer\ Network",
    "CounterStrike",
    "Ctrip.com?",
    "Cubadebate",
    "Common\ Unix\ Printer\ System",
    "Cutey\ Honey\ Flash\ Bittorrent\ tracker",
    "Concurrent\ Versions\ System",
    "Cyber12\ Bittorrent\ tracker",
    "CyberCTM.com",
    "Cyworld.com",
    "Dagbladet.no",
    "DailyBooth.com",
    "DailyStrengh.org",
    "DailyMail.co.uk",
    "Dailymotion.com",
    "Dakaractu.com",
    "Dangdang.com",
    "Danishbits\ Bittorrent\ tracker",
    "Dantri.com.vn",
    "Dap-News.com",
    "data.hu",
    "Daum.net",
    "Daum\ Mail",
    "Davidov.do.am",
    "Day.az",
    "DB2",
    "Dba",
    "DBS\ Bank\ (dbs.com.sg)",
    "Datagram\ Congestion\ Control\ Protocol",
    "Distributed\ Computing\ Environment\ -\ Remote\ Procedure\ Call",
    "DCinside.com",
    "DCN\ Measurement\ Subsystems",
    "Datagram\ Delivery\ Protocol",
    "D-II\ Data\ Exchange",
    "Dealfish.co.th",
    "Debian/Ubuntu\ Update",
    "Digital\ Equipment\ Corporation",
    "Decayenne.com",
    "DeepSeek\ Bittorrent\ tracker",
    "Deer\ Hunter\ 2014",
    "Deezer.com",
    "Defimedia.info",
    "Delfi",
    "Delicious.com",
    "Delta\ Search",
    "DepositFiles.com",
    "derStandard.at",
    "DeskAway",
    "Destiny",
    "Detik.com",
    "Detiknews.com",
    "DeviantArt.com",
    "Distributed\ File\ System",
    "Dissimilar\ Gateway\ Protocol",
    "Dynamic\ Host\ Configuration\ Protocol",
    "Dynamic\ Host\ Configuration\ Protocol\ for\ IPv6",
    "Diameter",
    "Dictionary\ Server",
    "Digg.com",
    "Digikala",
    "Digital\ River",
    "DigitalVerse.org",
    "Diino.com",
    "Dynamic\ Internet\ Messaging\ Program",
    "Diodeo.com",
    "Datagram\ Inter-ORB\ Protocol",
    "Dir.bg",
    "DirectConnect\ (NMDC)",
    "DirectDownload\ Links",
    "DirectREV.com",
    "DirecTV.com",
    "DireTube.com",
    "Disaboom.com",
    "Discuss",
    "DISTCC",
    "DivShare.com",
    "Dmm.co.jp",
    "Domain\ Name\ Service",
    "Dnshop.com",
    "Docstoc.com",
    "Doisongphapluat.com",
    "Dol2day.com",
    "DoneDeal.ie",
    "Donga.com",
    "DontStayIn.com",
    "Doodle\ Jump",
    "Doorblog.jp",
    "Dorgio.mn",
    "Douban.com",
    "Dr.dk",
    "Draugas.lt",
    "Draugiem.lv",
    "Distributed\ Relational\ Database\ Architecture",
    "Dreamora\ Bittorrent\ tracker",
    "DreamWiz.com",
    "Dropbox.com",
    "DrukNet.bt\ (Bhutan\ Telecom)",
    "Drupal.org",
    "Dynamic\ Source\ Routing",
    "Dstv",
    "Datagram\ Transport\ Layer\ Security",
    "Dynamic\ Trunking\ Protocol",
    "Dubizzle.com",
    "Duowan.com",
    "DV.is",
    "DynamicIntranet.com",
    "EarthCam.com",
    "Eastmoney.com",
    "Easytravel.com.tw",
    "eBay.com",
    "eBuddy.com",
    "Echo",
    "Echoroukonline.com",
    "Ecuavisa",
    "EdgeCast\ Networks\ CDN",
    "Edonkey",
    "Educarriere",
    "Egloos",
    "Egnyte\ Enterprise\ File\ Sharing",
    "Exterior\ Gateway\ Protocol",
    "Enhanced\ Interior\ Gateway\ Routing\ Protocol",
    "Ekantipur.com",
    "Eksisozluk",
    "EkstraBladet.dk",
    "El.balad",
    "Elblog",
    "ElCat.kg",
    "Elcomercio.pe",
    "Eldeber",
    "Elftown.com",
    "ElHeddaf.com",
    "Elheraldo.hn",
    "Elhourriya",
    "Elle.com.tw",
    "Elluminate.com",
    "Elmundo.es",
    "Elnashra.com",
    "ElNuevoDia.com",
    "ElNuevoDiario.com.ni",
    "ElPais.com",
    "Elsalvador.com",
    "Eltiempo",
    "Eluniverso",
    "Elwatannews",
    "Emag",
    "Empas",
    "EMCON",
    "Emol.com",
    "Empire:\ Four\ Kingdoms",
    "Encapsulation\ Header",
    "Encuentra24.com",
    "Energy-Torrent\ Bittorrent\ tracker",
    "Eons.com",
    "Epernicus.com",
    "EndPoint\ Mapper",
    "eRoom.net",
    "eSnips.com",
    "Encapsulating\ Security\ Payload",
    "ESPN.go.com",
    "ESPNCricinfo.com",
    "Essahraa",
    "EssirageNet",
    "Established\ TCP\ Connection",
    "Etao.com",
    "Ethernet",
    "Ethernet\ Over\ IP",
    "Ethiojobs.net",
    "EthioTube.net",
    "ETSI\ Lawful\ Interception\ TS\ 10\ 232-1\ V2.1.1",
    "Ettoday.net",
    "Eve\ Online",
    "Evernote.com",
    "EverQuest\ -\ EverQuest\ II",
    "Evony.com",
    "exacqvision",
    "Exblog.jp",
    "Expatriates",
    "Expedia.fr",
    "ExperienceProject.com",
    "Exploroo.com",
    "Expressen",
    "ExtremeBits\ Bittorrent\ tracker",
    "ExtremeNova\ Bittorrent\ tracker",
    "Eyejot.com",
    "Eyny.com",
    "Ezfly.com",
    "MyMusic.net.tw",
    "EzTravel.com.tw",
    "Facebook",
    "Facebook\ Apps",
    "facebook\ mail",
    "Facebook\ Messenger",
    "Facenama.com",
    "Faceparty.com",
    "Faces.com",
    "Apple\ FaceTime",
    "FarmVille",
    "FarsNews.com",
    "FashionGuide.com.tw",
    "Fatakat.com",
    "FC2.com",
    "feiliao",
    "Femina",
    "Fenopy\ Bittorrent\ tracker",
    "Fetion",
    "FetLife.com",
    "Fibre\ Channel",
    "FijiTimes.com",
    "FileDropper.com",
    "FileHost.ro",
    "filefactory.com",
    "FileFlyer",
    "Fileguri.com",
    "Filei.co.kr",
    "Filelist.ro",
    "Filemail.com",
    "FileMaker\ Pro",
    "filepost.ru",
    "Filer.cx",
    "filer.net",
    "FileRIO",
    "Files.to",
    "filesend.net",
    "FileServe.com",
    "WWW\ File\ Share\ Pro\ (wfshome.com)",
    "Filesovermiles.com",
    "FilesTube.com",
    "Filetopia.org",
    "Fillos\ de\ Galicia\ (fillos.org)",
    "FilmAffinity.com",
    "Find\ My\ iPhone",
    "FINN.no",
    "FIRE",
    "Firefox\ Update",
    "Flash\ Media\ Playback",
    "Adobe\ Flash\ Plugin\ Update",
    "FledgeWing.com",
    "Flickr",
    "Flipkart.com",
    "Flixster.com",
    "Flumotion.com",
    "Flurry",
    "Fluxiom.com",
    "FlyProxy.com",
    "Flycell.ec",
    "Flycell.pe",
    "Fnb",
    "FogCreek.com",
    "ForeningsSparbanken\ (swedbank.se)",
    "Fortunechina.com",
    "Forum.ge",
    "Fotki.com",
    "Fotolog.com",
    "Fotoweb.fotoware.com",
    "Foursquare.com",
    "Fox\ Business\ Network",
    "Foxmovies.jp",
    "FoxNews.com",
    "FoxSports.com",
    "Foxy",
    "Free",
    "Free\ Music\ Download\ Pro\ -\ Downloader\ and\ Player",
    "FreeBSD\ Updates",
    "FreeeTV.com",
    "Freeloader\ Bittorrent\ tracker",
    "Freemail.hu",
    "freenet",
    "Freeproxies.org",
    "Freetorrent\ Bittorrent\ tracker",
    "FreeWheel",
    "FriendsReunited.com",
    "Friendster.com",
    "FriendVox.com",
    "fring\ -\ Peer\ to\ Peer\ Mobile\ VOIP",
    "FrostWire\ Bittorrent\ client",
    "Fruhstuckstreff.de",
    "Fruit\ Ninja",
    "Fsecure",
    "Fsecure\ Update",
    "File\ Transfer\ Protocol",
    "File\ Transfer\ Protocol\ Data",
    "File\ Transfer\ Protocol\ Secure",
    "Fubar.com",
    "Funshion\ video\ player",
    "Fuze\ meeting",
    "Gadu-Gadu",
    "GaiaOnline.com",
    "Gamebase.com.tw",
    "Gameloft\ Games",
    "Gamer.com.tw",
    "GamerDNA.com",
    "Games.co.id",
    "Gamesmomo.net",
    "Ganji.com",
    "GaraaNews.com",
    "Generic\ Attribute\ Registration\ Protocol",
    "Gather.com",
    "GatherPlace.net",
    "Gays.com",
    "Gazeta.pl",
    "Gazetaexpress",
    "Gazzetta",
    "Gbridge.com",
    "Google\ Cloud\ Messaging",
    "Google\ Cloud\ Storage",
    "Geni.com",
    "Gerasanews.com",
    "Gettyimages",
    "Gfan.com",
    "Gateway-to-Gateway\ Protocol",
    "GhanaWeb.com",
    "GhostSurf",
    "Gigacircle",
    "gigasize.com",
    "GigaTribe.com",
    "GigaUP.fr",
    "General\ Inter-ORB\ Protocol",
    "General\ Inter-ORB\ Protocol\ Secure",
    "Gizmo",
    "Glide\ services",
    "Globalpublishers",
    "Globo.com",
    "Google\ Mail",
    "Gmail\ Basic",
    "Google\ Chat",
    "Gmail\ drive",
    "Gmail\ Mobile",
    "Gmarket.co.kr",
    "GMTP",
    "GMX\ webmail",
    "GNUnet",
    "Gnutella",
    "Goal.com",
    "Gob.bo",
    "GoBoogy",
    "Gogo.mn",
    "Gogobox.com.tw",
    "Gogoyoko.com",
    "Gohappy.com.tw",
    "Golden\ Village",
    "Gomeetnow",
    "GOMTV.net\ (VOD)",
    "Goo.ne.jp",
    "Goodreads.com",
    "Google.com",
    "Google\ Accounts",
    "Google\ ads",
    "Google\ Analytics",
    "Google\ App\ Engine",
    "Google\ Cache",
    "Google\ Desktop\ (discontinued\ on\ 2011-09-14)",
    "Google\ Documents\ (aka\ Google\ Drive)",
    "Google\ Earth",
    "Google\ Generic",
    "Google\ groups",
    "Google\ Maps",
    "Google\ Picasa",
    "Google\ Play",
    "Google\ Plus",
    "Google\ Safe\ Browsing",
    "Google\ Analytics",
    "Google\ Toolbar",
    "Google\ Translate",
    "Goplan",
    "GossipLankaNews.com",
    "GoToDevice\ Remote\ Administration",
    "GoToMeeting\ Online\ Meeting",
    "GoToMyPC\ Remote\ Access",
    "Gougou.com",
    "Gratisindo.co.id",
    "Gravatar",
    "Generic\ Routing\ Encapsulation",
    "GREE\ Games",
    "Grid.mk",
    "Grono.net",
    "Microsoft\ Office\ Groove",
    "Grooveshark.com",
    "Groupon",
    "Groupwise\ (Novell)",
    "Gsshop.com",
    "Google\ GStatic",
    "GT\ Racing\ 2:\ The\ Real\ Car\ Experience",
    "Google\ Hangouts\ (formerly\ Google\ Talk)",
    "GPRS\ Tunneling\ Protocol",
    "GPRS\ Tunneling\ Protocol\ version\ 2",
    "GuamPDN.com",
    "Gudanglagu.com",
    "Gulfup.com",
    "Gumtree.com",
    "GyaO.yahoo.co.jp",
    "H225",
    "H245",
    "h248\ Protocol\ (Megaco)\ in\ binary\ mode",
    "h248\ Protocol\ (Megaco)\ in\ text\ mode",
    "Habbo.com",
    "Haber7",
    "Half-Life\ -\ Half-Life\ 2",
    "LogMeIn\ Hamachi",
    "Hangame.com",
    "Hankooki.com",
    "Hankyung.com",
    "Hao123",
    "Hardsextube.com",
    "Hardwarezone",
    "Hatena.ne.jp",
    "Haveeru.com.mv",
    "HBO\ GO",
    "Heraldm.com",
    "Nokia\ Here\ API",
    "Hespress.com",
    "Heureka.cz",
    "Hexun.com",
    "HGTV.com",
    "Hi5.com",
    "Hibapress",
    "High\ Entropy",
    "Hihi2",
    "HiNet\ Games\ (games.hinet.net)",
    "Host\ Identity\ Protocol",
    "Hirufm",
    "Hkgolden.com",
    "HLN.be",
    "Host\ Monitoring\ Protocol",
    "Hootsuite",
    "IPv6\ Hop-by-Hop\ Option",
    "HospitalityClub.org",
    "Host\ internal\ protocol",
    "Hotfile.com",
    "HotLine",
    "Hotspot\ Shield",
    "Hands\ On\ Video\ Relay\ Services",
    "Howcast.com",
    "HowStuffWorks.com",
    "HP\ Extended\ Local-Link\ Control",
    "Hs.fi\ (Helsingin\ Sanomat)",
    "HSBC\ Bank",
    "Hot\ Standby\ Router\ Protocol",
    "HyperText\ Transfer\ Protocol",
    "HTTP\ Tunnel",
    "HyperText\ Transfer\ Protocol\ Secure",
    "Hudong.com",
    "Huffington\ Post",
    "Hulu",
    "hungrygowhere",
    "Hurriyet.com.tr",
    "Hyves\ Games",
    "iGamer.com",
    "Integrated\ Net\ Layer\ Security\ Protocol",
    "i-Part.com.tw",
    "Iapp.com.tw",
    "Interactive\ Agent\ Transfer\ Protocol",
    "Inter\ Asterisk\ eXchange",
    "iBackup.com",
    "Ibay.com.mv",
    "Ibibo.com",
    "Independant\ Computing\ Architecture\ (Citrix)",
    "icall",
    "Internet\ Content\ Adaptation\ Protocol",
    "Inter-Control\ Center\ Communications\ Protocol",
    "icecast",
    "iCloud\ (Apple)",
    "Internet\ Control\ Message\ Protocol",
    "Internet\ Control\ Message\ Protocol\ for\ IP6",
    "Web-ICQ",
    "Icrt",
    "Identification\ Protocol",
    "iDNES.cz",
    "Inter\ Domain\ Policy\ Routing",
    "IDPR\ Control\ Message\ Transport\ Protocol",
    "Inter\ Domain\ Routing\ Protocol",
    "Ifeng.com",
    "Ifeng\ finance",
    "iFile.it\ (Filecloud.io)",
    "Ipsilon\ Flow\ Management\ Protocol",
    "iFolder.ru",
    "Igihe.com",
    "Internet\ Group\ Management\ Protocol",
    "Interior\ Gateway\ Protocol",
    "iHeartradio.com\ -\ iHeart.com",
    "Internet\ Inter-ORB\ Protocol",
    "IKEA.com",
    "Ikman.lk",
    "Ikub.al",
    "Internet\ Link\ (Transport\ protocol)",
    "Ilivid",
    "IloveIM.com",
    "Iltalehti.fi",
    "Ilta-Sanomat.fi",
    "ImageShack",
    "Internet\ Message\ Access\ Protocol\ version\ 4",
    "Internet\ Message\ Access\ Protocol\ Secure",
    "Internet\ Movie\ Database",
    "Imeem.com",
    "iMeet.com",
    "Imesh",
    "iMessage\ File\ Download",
    "Imgur.com",
    "Iminent.com",
    "Internet\ Messaging\ Program",
    "Impress.co.jp",
    "IMVU.com\ (Instant\ Message\ Virtuel\ Universe)",
    "Inbox.lv",
    "Incomplete\ virtual\ protocol",
    "Indaba\ Music",
    "Indeksonline",
    "Independent",
    "Index.hr",
    "Index.hu",
    "Indiatimes",
    "Indonetwork.co.id",
    "Indowebster.com",
    "Infinity\ Blade\ II",
    "IBM\ Informix",
    "ING\ Bank",
    "Inilah.com",
    "InMobi",
    "Inneractive",
    "Inquirer",
    "Instagram",
    "Intalking.com",
    "Interia.pl",
    "InterNations.org",
    "Interpark.com",
    "Intuit.com",
    "Investigator.co.ug",
    "Inwi",
    "iodine",
    "iOS\ over-the-air\ (OTA)\ update",
    "Internet\ Protocol",
    "Internet\ Protocol\ V6",
    "IANA\ Internet\ Protocol\ Number\ 253",
    "IANA\ Internet\ Protocol\ Number\ 254",
    "IP-in-IP\ tunneling",
    "Reliable\ Data\ Protocol\ over\ IP",
    "IANA\ Reserved\ Internet\ Protocol\ Number",
    "IP\ Payload\ Compression\ Protocol",
    "Internet\ Protocol\ Control\ Protocol",
    "IPCV\ Internet\ Packet\ Core\ Utility",
    "iperf",
    "IPDS\ MES\ Physical\ Layer\ Tester",
    "Internet\ Printing\ Protocol",
    "Internet\ Pluribus\ Packet\ Core",
    "IPsec\ Encapsulating\ Security\ Payload",
    "Internet\ Protocol\ Traffic\ Manager",
    "IPv6\ Control\ Protocol",
    "Internet\ Protocol\ eXchange",
    "Internet\ Protocol\ eXchange\ in\ IP",
    "Routine\ Information\ Protocol\ over\ IPX",
    "IPX\ Service\ Advertisement\ Protocol",
    "iQiyi.com",
    "Internet\ Relay\ Chat",
    "IRC-Galleria.net",
    "IRC\ File\ Transfer\ Data",
    "Internet\ Relay\ Chat\ Secure",
    "iRODS\ protocol",
    "Internet\ Reliable\ Transaction\ Protocol",
    "Internet\ Security\ Association\ and\ Key\ Management\ Protocol",
    "Internet\ Small\ Computer\ Systems\ Interface",
    "ISIS",
    "InterSwitch\ Link",
    "ISO\ Internet\ Protocol",
    "ISO\ Transport\ Protocol\ Class\ 4",
    "Issuu.com",
    "ISDN\ User\ Part",
    "Italki.com",
    "Itsmy.com",
    "iTunes",
    "ITV\ Player",
    "iWiW.hu",
    "Ja.is",
    "XMPP\ Protocol\ (Jabber)",
    "Jabber\ File\ Transfer",
    "Jaiku.com",
    "Jajah",
    "Jamaica\ Gleaner",
    "Jamaicaobserver",
    "JamiiForums.com",
    "JammerDirect.com",
    "Jango.com",
    "Jap",
    "JAVA-RMI",
    "Java\ Update",
    "JEDI\ (Citrix)",
    "HP\ Printer\ Job\ Language",
    "Jfranews.com",
    "JingDong",
    "Onjira.com\ (JIRA)",
    "JNE.co.id",
    "Jobs.af",
    "Jobs.bg",
    "jobsDB",
    "JobStreet.co.id",
    "Joongang\ Daily",
    "Jubii.dk",
    "Jumia",
    "Justin.tv",
    "Jutarnji.hr",
    "Juxtapose",
    "Kaioo.com",
    "Kaixin001.com",
    "Kajgana.com",
    "Kakaku.com",
    "KakaoStory",
    "KakaoTalk",
    "Kankan.com",
    "KapanLagi.com",
    "Kapook.com",
    "Karosgame.ru",
    "Kaskus.co.id",
    "Kaspersky.com",
    "Kaspersky\ Update",
    "Kazaa\ (FastTrack\ protocol)",
    "Kbstar.com\ (KB\ Kookmin\ Bank)",
    "KBS.co.kr",
    "Present",
    "KeezMovies.com",
    "Kemenkumham.go.id",
    "Khan.co.kr",
    "Khmer.news",
    "Khmerload.com",
    "KigaliToday.com",
    "Kijiji.ca",
    "KIK\ Messenger",
    "King\ Digital\ Entertainment",
    "Kingdom\ XXX\ Bittorrent\ tracker",
    "Kino",
    "Kiwibox.com",
    "KlikBCA.com",
    "Klix.ba",
    "Koha",
    "Kohsantepheapdaily",
    "Kolektiv",
    "Kompass.com",
    "Kompasiana.com",
    "Konaminet.jp",
    "Konga",
    "KoolIM.com",
    "Kooora.com",
    "Kproxy.com",
    "Kerberos",
    "Kryptolan",
    "Kstna",
    "Ku6.com",
    "KuenselOnline.com",
    "Kugou/Kugoo",
    "Kupujemprodajem",
    "Kurir",
    "Kurir\ Info",
    "Kuxun.cn",
    "Kwejk",
    "Layer\ 2\ Tunneling\ Protocol",
    "LaBanquePostale.fr",
    "Lady8844.com",
    "Lajmi",
    "Local\ Area\ Network",
    "Lanacion.com.ar",
    "Lankadeepa",
    "LanShark",
    "Lapagina",
    "Lapatilla",
    "La\ Poste\ Webmail",
    "Laprensa.com",
    "Laprensagrafica",
    "LaRedoute.fr",
    "Locus\ Address\ Resolution\ Protocol",
    "Last.fm",
    "LastPass.com",
    "Lativ.com.tw",
    "Lava\ Lava",
    "Lazada",
    "Line\ Control\ Protocol",
    "Lighweight\ Directory\ Access\ Protocol",
    "Lighweight\ Directory\ Access\ Protocol\ Secure",
    "Livedoor\ Blog",
    "Leaf\ 1",
    "Leaf\ 2",
    "LeapFILE.com",
    "LeBonCoin.fr",
    "Leral.net",
    "leteckaposta.cz",
    "LeTV.com",
    "Level\ 3\ Communications\ CDN",
    "lexpress.mu",
    "Lgeshop.com",
    "Libero.it",
    "LibraryThing.com",
    "Lider\ Bet",
    "Life",
    "LifeKnot.com",
    "Line",
    "LineGames.jp",
    "LINE\ WIND\ runner\ application",
    "Lineage\ II",
    "Linio",
    "LinkedIn.com",
    "LintasBerita.com\ -\ Lintas.me",
    "LionAir.co.id",
    "LionTravel.com",
    "Listografy.com",
    "Windows\ Live\ Groups",
    "Windows\ Live\ Hotmail",
    "Microsoft\ Office\ Live\ Meeting",
    "Windows\ Live\ Mesh",
    "Windows\ Live\ File\ Storage",
    "Livedoor.com",
    "LiveInternet.ru",
    "LiveJournal.com",
    "Windows\ Live\ Hotmail\ Attachements",
    "Live\ hotmail\ for\ mobile",
    "Livemocha.Com",
    "LiveRail",
    "Livingsocial.co.id",
    "Logical\ Link\ Control",
    "Limelight\ Networks\ CDN",
    "LLP",
    "load.to",
    "Load\ Balancing",
    "Lokalisten.de",
    "Loopback:XEROX",
    "Lotour.com",
    "Lotte.com",
    "Lotterypost.com",
    "IBM\ SmartCloud",
    "IBM\ Lotus\ Sametime",
    "Lotus\ Notes",
    "Line\ Printer\ Remote",
    "Link\ Quality\ Report",
    "Lrytas.lt",
    "LTT",
    "LUKE",
    "Lun",
    "LunarStorm.se",
    "Lvping.com",
    "Microsoft\ Lync",
    "Microsoft\ Lync\ Online",
    "MTP2\ User\ Peer-to-Peer\ Adaptation\ Layer",
    "MTP2\ User\ Adaptation\ Layer",
    "MTP3\ User\ Adaptation\ Layer",
    "Maaii\ application",
    "Maannews.net",
    "magicJack",
    "Magu-Magu\ (aka\ 2013\ for\ Kakao)",
    "Mail2000.com.tw",
    "Mail189.cn",
    "Mail.ru\ games",
    "Mail.ru\ Moimir",
    "Mail.ru\ Webagent",
    "Mail.ru\ Webmail",
    "Mail.ru\ Agent",
    "Mako.co.il",
    "Maktoob\ mail",
    "Malformed\ virtual\ protocol",
    "Maltapark.com",
    "MaltaToday.com.mt",
    "Mana.pf",
    "Mandriva\ Update",
    "MANET\ Protocols",
    "Mangocity.com",
    "manolito",
    "MS\ Exchange\ Message\ API",
    "MapQuest.com",
    "Mapy",
    "Marca.com",
    "Marebpress",
    "Marktplaats.nl",
    "Mashable.com",
    "Ma-Share.com",
    "Match.com",
    "Maybank2u.com",
    "iMBC.com",
    "Mbl.is",
    "MBN.co.kr",
    "McAfee\ Client\ update",
    "Multipoint\ Communication\ Service",
    "MediaFire.com",
    "MEETin.org",
    "Cisco\ MeetingPlace",
    "MeetMe.com",
    "MeetTheBoss.tv",
    "Meetup.com",
    "MeeVee",
    "MEGA",
    "Megaproxy",
    "megashares.com",
    "Megaupload",
    "Megavideo",
    "Mekusharim.walla.co.il",
    "Mendeley.com",
    "MercadoLibre.com",
    "Mercador\ (now\ Olx.ro)",
    "MERIT\ Internodal\ Protocol",
    "MerrJep.com",
    "MessengerFX.com",
    "Metacafe.com",
    "MFE\ Network\ Services\ Protocol",
    "Media\ Gateway\ Control\ Protocol",
    "Mgoon.com",
    "Mibbit\ chat\ network",
    "Mobile\ Internetworking\ Control\ Protocol",
    "Mihanblog.com",
    "Mihanwebads",
    "Mikogo",
    "Milanuncios",
    "Milliyet.com.tr",
    "IMP\ mobile\ version",
    "Minecraft\ -\ Pocket\ Edition",
    "Mobile\ IPv6",
    "Miro\ (getmiro.com)",
    "Mistreci.com",
    "MiTalk\ Messenger\ (Miliao)",
    "Mixi.jp",
    "Mixpanel",
    "Mk.co.kr",
    "Microsoft\ Multimedia\ Streaming",
    "Manufacturing\ Message\ Specification\ (ISO\ 9506\ )",
    "MultiMedia\ Messages\ Encapsulation",
    "Mobage\ games",
    "IP\ Mobility",
    "Mobile01.com",
    "Mobile\ IP",
    "Mobile\ Me",
    "Mobile\ Header",
    "Mobile\ Market",
    "Mobilink",
    "MOcean",
    "MocoSpace.com",
    "Moe.gov",
    "MOG.com",
    "Livestream.com",
    "Momoshop.com.tw",
    "Monex.com",
    "Money163.com",
    "MoneyDJ.com",
    "Monitor.co.ug",
    "Monster.com",
    "Moov.mg",
    "Mop.com",
    "MoreFreeCamSecrets.com",
    "Mosaiquefm",
    "Motika.com.mk",
    "Mount",
    "MouthShut.com",
    "Mover",
    "Mozilla.com\ -\ Mozilla.org",
    "Mozzi",
    "MP3\ Rocket\ application",
    "MPEG-Transport\ Stream",
    "Multiprotocol\ Packet\ Label\ Switching",
    "Multi\ Protocol\ Label\ Switching\ data-carrying\ mechanism",
    "M+\ Messenger",
    "MapQuest.com",
    "IBM\ Websphere\ MQ",
    "Microsoft\ Communicator",
    "MSN\ Messenger",
    "MSN\ groups",
    "MSN\ Search",
    "MSN\ Video",
    "MSN\ live\ for\ Mobile",
    "Message\ Session\ Relay\ Protocol",
    "Microsoft\ Remote\ Procedure\ Call",
    "mt",
    "Multicast\ Transport\ Protocol",
    "MTV",
    "Mubi",
    "Mudah.mi",
    "Multiply.com",
    "Multiupload.com",
    "Musica.com",
    "Mute",
    "Multiplexing",
    "Muxlim",
    "Mxit.com",
    "My\ Opera",
    "My\ Talking\ Tom",
    "My\ Yahoo",
    "MyAnimeList.net",
    "Myauto",
    "MyChurch.org",
    "MyDownloader.net",
    "MyHeritage.com\ -MyHeritage.fr",
    "Myjoyonline",
    "MyLife.com",
    "MyPeople\ Messenger",
    "My\ Pocket",
    "MySpace.com",
    "MySpace\ Video",
    "MySQL\ Protocol",
    "Myvideo.de",
    "Mywebsearch.com",
    "MyYearBook",
    "Nacion.com",
    "NagarikNews.com",
    "Nairaland.com",
    "Namba.kg",
    "Napster.com",
    "NBMA\ Address\ Resolution\ Protocol",
    "NASA.gov",
    "Nasza\ Klasa\ (nk.pl)",
    "Nate\ Mail",
    "Nate.com",
    "Nation.co.ke",
    "NationalGeographic.com",
    "National-lottery.co.uk",
    "NationNews.com",
    "Naver\ Corporation\ (formerly\ NHN\ Corporation)",
    "Naver\ Blog",
    "Naver",
    "Naver\ Drive",
    "Naver\ Mail",
    "NBA.com",
    "Nba\ China",
    "Netbios\ Name\ Service",
    "Netware\ Core\ Protocol",
    "Network\ Data\ Management\ Protocol",
    "Nduoa.com",
    "Nefsys.com",
    "Nend.net",
    "NeoBux.com",
    "Net.hr",
    "Netbios",
    "Bulk\ Data\ Transfer\ Protocol",
    "NetBSD\ Updates",
    "Netflix.com",
    "Cisco\ Netflow",
    "Neti",
    "Netload.in",
    "Netlog.com",
    "NetMarble.com",
    "NetMeeting\ ILS",
    "Nettby.no",
    "News24.com",
    "News.am",
    "News",
    "News.mn",
    "Newsit.gr",
    "Newvision",
    "Nexian.co.id\ -\ Nexian.us.to",
    "Nexon.com",
    "Nexopia.com",
    "Nextmedia",
    "National\ Football\ League\ (NFL.com)",
    "Network\ File\ System",
    "NGOPost.org",
    "Nicovideo.jp\ (aka\ Nico\ Nico\ Douga)",
    "Nielsen",
    "Nifty.com",
    "Nike.com",
    "Nikkei.com",
    "Nimbuzz",
    "Ning.com",
    "Njuskalo.hr",
    "Network\ Lock\ Manager",
    "Netware\ Link\ Services\ Protocol",
    "Network\ News\ Transport\ Protocol",
    "Network\ News\ Transport\ Protocol\ Secure",
    "ESET\ NOD32\ Antivirus\ Updates",
    "Nokia",
    "Nokia\ Ovi",
    "Nonghyup\ Bank\ (Nohyup.com)",
    "Nordea.dk",
    "Symantec\ Norton\ AntiVirus\ Updates",
    "Noticias24",
    "Novinky.cz",
    "NOWnews.com",
    "NRK.no",
    "NSFNET-IGP",
    "Name\ Service\ Provider\ Interface",
    "Network\ Time\ Protocol",
    "Ntv.co.jp",
    "Nu.nl",
    "Network\ Voice\ Protocol\ II",
    "NYDailyNews.com",
    "NYTimes.com",
    "NZHerald.co.nz",
    "Online\ Certificate\ Status\ Protocol",
    "Octopz.com",
    "OctoShape",
    "Odnoklassniki.ru",
    "odsiebie.najlepsze.net",
    "Microsoft\ Office\ 365",
    "OfficeDepot.fr",
    "Offnews",
    "OICQ",
    "OkCupid",
    "Okezone.com",
    "OKWave.jp",
    "Olx.com",
    "Onclickads",
    "OneWorld.net",
    "OneHub.com",
    "OneLife.fm",
    "Onet.pl",
    "OneWorld.org",
    "OneWorld\ TV",
    "Onlinedown.net",
    "Onlinekhabar.com",
    "Onliner.by",
    "Onlive",
    "Oovoo",
    "Ooyala.jp",
    "OpenDiary.com",
    "OpenBSD\ Updates",
    "OpenFT",
    "OpenGW\ (VPN\ Gate)",
    "Opensooq.com",
    "OpenStreetMap",
    "OpenVPN",
    "Opera\ Update",
    "Oracle",
    "Orange.com",
    "Orange\ webmail",
    "Orb\ (acquired\ by\ Qualcomm\ Connected\ Experiences)",
    "Orf.at",
    "Origo.hu",
    "Orkut.com",
    "OSI\ Network\ Layer",
    "Open\ Shortest\ Path\ First",
    "Ouedkniss.com",
    "OUTeverywhere.com",
    "Outlook\ Web\ Access\ (Office\ 365)",
    "Ovaciondigital",
    "Over-blog",
    "Outlook\ Web\ App",
    "Paipai.com",
    "PalTalk",
    "Paltalk\ audio\ chat",
    "PalTalk\ Transfer\ Protocol",
    "Paltalk\ video",
    "Palweather",
    "Panda\ Update",
    "Pando",
    "Pandora\ Radio",
    "Pandora.tv",
    "Panet.co.il",
    "Pantip.com",
    "Password\ Authentication\ Protocol",
    "Paraguay.com",
    "Paran",
    "Partis.si",
    "PartnerUp.com",
    "PartyPoker.com\ -\ PartyAccount.com",
    "PassportStamp.com",
    "Path",
    "Payeasy.com.tw",
    "Paypal.com",
    "Pazar3.mk",
    "PCAnywhere",
    "PCgames.com.cn",
    "PChome.com.tw",
    "PClady.com.cn",
    "PConline.com.cn",
    "PeerCast",
    "PeerGuardian",
    "Pengyou.com",
    "People.com.cn",
    "Perfect\ Dark",
    "Perforce\ Protocol",
    "Perfspot.com",
    "Persianblog.ir",
    "PetitesAnnonces.pf",
    "Peyvandha.ir",
    "PGM\ Reliable\ Transport\ Protocol",
    "Philenews.com",
    "Photobucket.com",
    "PHProxy",
    "Phweet.com",
    "Pichat.net",
    "Pik.ba",
    "Protocol\ Independent\ Multicast",
    "Pmang.com",
    "Pingsta.com",
    "Pinterest.com",
    "Piolet.net",
    "Private\ IP\ Encapsulation\ within\ IP",
    "Pixiv.net",
    "Pixnet.net",
    "Plants\ vs\ Zombies",
    "Plaxo.com",
    "Playahead",
    "PlayStation.com",
    "Plenty\ Of\ Fish",
    "Plius.lt",
    "Plurk.com",
    "PNNI\ over\ IP",
    "POCO.cn",
    "Pogo.com",
    "Point",
    "Poker\ Stars",
    "Pole-emploi.fr",
    "Post\ Office\ Protocol\ (Version\ 3)",
    "Secure\ POP3",
    "Pornhub.com",
    "Port\ Mapper",
    "PostgreSQL",
    "Postimees.ee",
    "Pou",
    "ISO\ 8823\ Presentation\ Protocol",
    "PIPI\ Film",
    "PPlive",
    "Ppomppu",
    "Point-to-Point\ Protocol",
    "Point-to-Point\ Protocol\ Over\ Ethernet",
    "Pps.tv",
    "PPStream\ -\ P2P\ based\ Streamed\ Media",
    "Point-to-Point\ Tunneling\ Protocol",
    "Pptv.com",
    "Prensa",
    "Prensalibre",
    "Present",
    "Press24.mk",
    "Pressan.is",
    "PriceMinister.com",
    "PriceRunner",
    "Primewire",
    "Private\ encryption\ scheme",
    "Privax.us",
    "Packet\ Radio\ Measurement",
    "Prodavalnik.com\ (now\ Olx.bg)",
    "Property\ Guru",
    "Protothema",
    "Proxeasy.com",
    "Proxono.org\ -\ Proxono.info",
    "Psiphon",
    "Playstation\ Network",
    "Performance\ Transparency\ Protocol",
    "Puls24.mk",
    "Punyumunyu",
    "PUP",
    "Puzzle\ and\ Dragon",
    "Packet\ Video\ Protocol",
    "Pseudo\ Wire\ Emulation",
    "Q.931",
    "Qapacity.com",
    "Qatarliving.com",
    "QIK\ Video",
    "QNX",
    "Qoo10",
    "QQ",
    "QQ\ Blog",
    "QQ\ finance",
    "QQ\ Games",
    "QQ\ Lady",
    "QQ\ Mail",
    "QQ\ News",
    "QQ\ File\ Transfer",
    "QQ.com",
    "QQ\ WeiBo",
    "QQDownload",
    "QQLive\ Network\ Player",
    "QQMusic",
    "QQStream",
    "Qtrax\ Bittorrent\ tracker",
    "Quake",
    "Quantcast",
    "Quantum\ DXi",
    "Quarterlife.com",
    "QuizUp:\ The\ Biggest\ Trivia\ Game\ In\ The\ World!",
    "Qunar.com",
    "QVOD\ Player",
    "Qzone.qq.com",
    "R10",
    "Radiko.jp",
    "Radio1.pf",
    "Remote\ Authentication\ Dial-In\ User\ Service",
    "RadiusIM.com",
    "Radmin",
    "Rakuten.co.jp",
    "Rambler.ru",
    "Rambler\ webmail",
    "RapidShare.com",
    "rapidupload.com",
    "Raulken\ Bittorrent\ tracker",
    "Ravelry.com",
    "Raya",
    "Rayfile\ Bittorrent\ tracker",
    "Remote\ Desktop\ Protocol\ (Windows\ Terminal\ Server)",
    "Real\ Data\ Transport",
    "Realtor.com",
    "Reddit.com",
    "RedHat\ Update",
    "Redtube.com",
    "Reklama5.mk",
    "Renren.com",
    "Repubblica.it",
    "Republika.co.id",
    "ResearchGATE.net",
    "RetroShare",
    "Reuters.com",
    "ReverbNation.com",
    "Reverso.net",
    "Remote\ Frame\ Buffer",
    "Rhapsody",
    "Ricardo.ch",
    "Rimnow.com",
    "Ringring",
    "Routing\ Information\ Protocol\ V1",
    "Routing\ Information\ Protocol\ V2",
    "Routing\ Internet\ Protocol\ ng1",
    "Remote\ Login",
    "Resource\ Location\ Protocol",
    "Remote\ Method\ Invocation\ over\ Internet\ Inter-ORB\ Protocol",
    "Rmvbusters\ Bittorrent\ tracker",
    "Roboform",
    "Robust\ Header\ Compression",
    "Rovio\ Entertainment",
    "Royanews",
    "Remote\ Procedure\ Call",
    "IBM\ Remote\ Program\ Load",
    "Rquota",
    "Remote\ Shell",
    "RSS",
    "Rstat",
    "Reservation\ Protocol",
    "Original\ experimental\ academic\ or\ proprietary\ protocols",
    "Remote\ synchronous\ (file\ transfer)",
    "Rt.com",
    "Real\ Time\ Control\ Protocol",
    "rtl.de",
    "Real\ Time\ Messaging\ Protocol",
    "Real\ Time\ Protocol",
    "Real\ Time\ Streaming\ Protocol",
    "Rtvslo.si",
    "Rudaw",
    "RuneScape",
    "Rusers",
    "Ruten.com.tw",
    "Rutracker\ Bittorrent\ tracker",
    "Ruv.is",
    "MIT\ Remote\ Virtual\ Disk",
    "Ryanair.com",
    "Ryze.com",
    "S1\ Application\ Protocol",
    "S-oman.net",
    "Saavn\ Bollywood\ Music",
    "Saba\ Meeting",
    "Sabay.com.kh",
    "Saberindo.co.id",
    "Sabq.org",
    "Sahafah",
    "SaharaMedias.net",
    "Sahibinden.com",
    "Saitebi.ge",
    "Sakura.ne.jp",
    "Salesforce.com",
    "Sameerbook.com",
    "Samsung",
    "Samsung\ Apps",
    "Sana.sy",
    "Sanook.com",
    "SAP",
    "Sapo.mz\ -\ Sapo.pt",
    "Sarayanews",
    "SATNET\ and\ Backroom\ EXPAK",
    "SATNET\ Monitoring",
    "savefile.com",
    "SayClub.com",
    "Sbs.co.kr",
    "Semaphore\ Communications\ Sec.\ Pro.",
    "System\ Center\ Configuration\ Manager",
    "Skinny\ Client\ Control\ Protocol",
    "Stream\ Connection\ Control\ Part",
    "SceneHD\ Bittorrent\ tracker",
    "Scheduled\ Transfer\ Protocol",
    "ScienceStage.com",
    "Scispace.com",
    "ScorecardResearch",
    "SCPS",
    "Scribd.com",
    "Stream\ Control\ Transmission\ Protocol",
    "Sdo.com",
    "Source\ Demand\ Routing\ Protocol",
    "Searchnu",
    "SecondLife.com",
    "Secure\ VMTP",
    "Intertrust.com",
    "Seesaa",
    "Seesmic.com",
    "Segye.com",
    "SendSpace",
    "Seneweb.com",
    "Seoul.co.kr",
    "Setopati",
    "Seznam.cz",
    "SFR.fr",
    "sgCarMart",
    "Shabiba",
    "Share",
    "sharebee.com",
    "Sharebox\ Bittorrent\ tracker",
    "Microsoft\ SharePoint",
    "Microsoft\ SharePoint\ Administration\ Application",
    "Microsoft\ SharePoint\ Blog\ Management\ Application",
    "Microsoft\ SharePoint\ Calendar\ Management\ Application",
    "Microsoft\ SharePoint\ Document\ Management\ Application",
    "SharePoint\ Online",
    "Sharereactor\ Bittorrent\ tracker",
    "ShareTheMusic.com",
    "Shazamid.com",
    "Shekulli.com.al",
    "Shelfari.com",
    "Shim6\ Protocol",
    "Shinhan.com",
    "Shobiddak.com",
    "ShoutCast",
    "ShowMyPc.com",
    "Shutterfly.com",
    "Siebel\ CRM",
    "Sigmalive",
    "Silverlight\ (Microsoft\ Smooth\ Streaming)",
    "Simple\ Message\ Protocol",
    "simpleupload.net",
    "Sina.com.cn",
    "Sina\ blog",
    "Sina\ finance",
    "Sina\ News",
    "Sina\ Video",
    "Sina\ Weibo",
    "Siol.net",
    "Session\ Initiation\ Protocol",
    "SIP-SOAP",
    "SISTIC\ Singapore",
    "Skee\ Ball\ Arcade",
    "Skelbiu.lt",
    "SKIP",
    "Skroutz.gr",
    "Sky",
    "SkyPlayer.sky.com",
    "Skyblog",
    "Skycn.com",
    "Windows\ Live\ SkyDrive",
    "Windows\ Live\ SkyDrive\ Login",
    "Skype",
    "Skyrock.com",
    "Slacker\ Personal\ Radio",
    "Slando.by\ (now\ Olx.by)",
    "SlideShare",
    "Slingbox",
    "SoulSeek",
    "Sparse\ Mode",
    "Smart\ AdServer",
    "SMARTalk",
    "Server\ Message\ Block\ (Windows\ File\ Server)",
    "Sme.sk",
    "Short\ message\ peer-to-peer\ protocol",
    "Simple\ Mail\ Transfer\ Protocol",
    "Simple\ Mail\ Transfer\ Protocol\ Secure",
    "Systems\ Network\ Architecture",
    "Sub-Network\ Access\ Protocol",
    "Snapchat",
    "Simple\ Network\ Management\ Protocol",
    "Sitara\ Networks\ Protocol",
    "Simple\ Network\ Paging\ Protocol",
    "Simple\ Object\ Access\ Protocol",
    "Social-tv.net",
    "SocialVibe.com",
    "socks2http",
    "SOCKet\ Secure\ v4",
    "SOCKet\ Secure\ v5",
    "Soft4fun.net",
    "SoftBank.com",
    "Softonic.com",
    "Softros\ LAN\ Instant\ Messenger",
    "Sogou.com",
    "Sohu.com",
    "Sohu\ blog",
    "Soku.com",
    "SoMud\ Bittorrent\ tracker",
    "So-net.ne.jp",
    "Sonico.com",
    "Nortel/SynOptics\ Netwok\ Management\ Protocol",
    "Sopcast.org",
    "Sophos\ update",
    "Soribada.com",
    "Soso.com",
    "Soufun.com",
    "SoundCloud.com",
    "Souq.com",
    "Southwest.com",
    "Soy502",
    "ISO\ 8327\ Session\ Protocol",
    "SPDY",
    "Speedtest",
    "Statistical\ Protocol\ IDentification",
    "Spiegel.de",
    "Sports.chosun.com",
    "Sports\ Illustrated",
    "SportsSeoul.com",
    "Spotify",
    "Sprint.com",
    "Sprite\ RPC\ Protocol",
    "Secure\ Packet\ Shield",
    "Structured\ Query\ Language\ Interface",
    "SquirrelMail",
    "SpectraLink\ Radio\ Protocol",
    "Service\ Location\ Protocol",
    "Ss.lv",
    "Service\ Specific\ Connection\ Oriented\ Protocol\ for\ M-Cast\ Env",
    "Simple\ Service\ Discovery\ Protocol",
    "Secure\ Shell",
    "Secure\ Socket\ Layer",
    "Stream\ protocol",
    "Stafaband.info",
    "Stagevu.com",
    "StandardMedia.co.ke",
    "Startimes.com",
    "StayFriends.de",
    "Stealthnet",
    "Steampowered.com",
    "Stick\ Cricket",
    "Stickam.com",
    "Stickyads",
    "Stockq.org",
    "Spanning\ Tree\ Protocol",
    "StreamAudio.com",
    "STudiVZ.net",
    "Stuff.co.nz",
    "StumbleUpon.com",
    "Session\ Traversal\ Utilities\ for\ NAT",
    "SCCP\ User\ Adaptation\ Layer",
    "Subway\ Surfers",
    "SugarCRM.com",
    "SugarSync.com",
    "Sulit.com.ph\ (now\ Olx.ph)",
    "SUN\ ND\ PROTOCOL_Temporary",
    "Suning.com",
    "Super.cz",
    "SupperSoccer.co.id",
    "Surrogafier.info",
    "SurveyMonkey.com",
    "Subversion",
    "SVT\ Play",
    "Swedbank.ee",
    "Swepiracy\ Bittorrent\ tracker",
    "IP\ with\ Encryption",
    "Sybase",
    "Symantec",
    "Sync",
    "TCP\ Syn\ flood",
    "Syslog",
    "T.38",
    "T-Online.de",
    "Tabelog.com",
    "Terminal\ Access\ Controller\ Access-Control\ System\ Plus",
    "Tagged.com",
    "Tagoo.ru",
    "Tahiti\ Infos",
    "Taiwanlottery.com.tw",
    "Taku\ File\ Bin\ (aka\ filesend.to)",
    "Talabat",
    "Lafango\ (formerly\ TalentTrove)",
    "Talkbiznow.com",
    "Taltopia.com",
    "Tamilthunder\ Bittorrent\ tracker",
    "Tango\ Video\ Calls",
    "Taobao\ Ad\ Network\ and\ Exchange",
    "Taobao",
    "Tapatalk",
    "Taringa.net",
    "Tasweernews.com",
    "Tawary.com",
    "Tayyar",
    "TCF",
    "Tchatche",
    "Transmission\ Control\ Protocol",
    "AnalogBit\ tcp-over-dns",
    "Tabular\ Data\ Stream",
    "TeacherTube.com",
    "TeachStreet.com",
    "Teamspeak\ v2",
    "TeamSpeak\ v3",
    "TeamViewer",
    "Techinline.com",
    "Telegraaf.nl",
    "Telegraf.rs",
    "Telegrafi",
    "Telegram",
    "Telnet",
    "Secure\ TELNET",
    "Teltel",
    "TempoInteraktif.com",
    "Tencent.com",
    "Teredo\ protocol",
    "TF1.fr",
    "Trivial\ File\ Transfer\ Protocol",
    "Tgbus.com",
    "The\ Auteurs",
    "The\ Simpsons:\ Tapped\ Out",
    "ThePirateBay.se",
    "Think",
    "Three.co.id\ -\ tri.co.id",
    "Xunlei/Thunder\ protocol",
    "Tianya.cn",
    "TIBCO\ RendezVous\ Protocol",
    "Ticketmonster.co.kr",
    "Portal.TidalTV.com",
    "Tiempo",
    "Tigerair",
    "Time\ Protocol",
    "Timesofmalta.com",
    "Timesofoman",
    "Tistory.com",
    "Transport\ Layer\ Security",
    "Tmal.com",
    "Transparent\ Network\ Service\ (Oracle)",
    "Telnet\ VIP",
    "To-mati.net",
    "Tocmai",
    "Toggle",
    "Tokbox.com",
    "Tokobagus.com",
    "Tonaton",
    "Top.channel",
    "Topky.sk",
    "Tor",
    "Torg.com",
    "TorrentDownloads.net",
    "Torrentz",
    "Tothemaonline",
    "touch",
    "Tower\ of\ Saviors",
    "TP++\ Transport\ Protocol",
    "Trademe.co.nz",
    "Traffic\ Factory",
    "transferbigfiles.com",
    "TravBuddy.com",
    "Travellerspoint.com",
    "Travelocity.com",
    "Travian.co.id",
    "Trend.az",
    "Trendmicro\ Update\ protocol",
    "Tribe.net",
    "Tribunnews.com",
    "Trinidadexpress",
    "Trinituner",
    "Trombi.com",
    "Trunk\ 1",
    "Trunk\ 2",
    "TRUSTe",
    "Ts",
    "TTP",
    "Tu.tv",
    "Tube8.com",
    "Tudou.com",
    "Tuenti.com",
    "Tukif",
    "Tumblr.com",
    "Tune",
    "TuneIn",
    "TuneWiki.com",
    "Tunisia-Sat.com",
    "Turn",
    "Turner",
    "Tut.by",
    "Tv.com",
    "Tv2.dk",
    "Tv4Play.se",
    "TVAnts\ Protocol",
    "TvKing",
    "Tvnet.lv",
    "TVU\ Network\ Player",
    "TWITCH",
    "Twitpic",
    "Twitter.com",
    "Twoo.com",
    "Ubuntu\ One",
    "uCoz.ru",
    "Universal\ Computer\ Protocol",
    "Udn.com",
    "User\ Datagram\ Protocol",
    "UDPLite",
    "Ukr",
    "Ultimahora",
    "ultrashare.net",
    "Ultrasurf",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 143",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 144",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 145",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 146",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 147",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 148",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 149",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 150",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 151",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 152",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 153",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 154",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 155",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 156",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 157",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 158",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 159",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 160",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 161",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 162",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 163",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 164",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 165",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 166",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 167",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 168",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 169",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 170",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 171",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 172",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 173",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 174",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 175",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 176",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 177",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 178",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 179",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 180",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 181",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 182",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 183",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 184",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 185",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 186",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 187",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 188",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 189",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 190",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 191",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 192",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 193",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 194",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 195",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 196",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 197",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 198",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 199",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 200",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 201",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 202",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 203",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 204",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 205",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 206",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 207",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 208",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 209",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 210",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 211",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 212",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 213",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 214",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 215",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 216",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 217",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 218",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 219",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 220",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 221",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 222",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 223",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 224",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 225",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 226",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 227",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 228",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 229",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 230",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 231",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 232",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 233",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 234",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 235",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 236",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 237",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 238",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 239",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 240",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 241",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 242",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 243",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 244",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 245",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 246",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 247",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 248",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 249",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 250",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 251",
    "IANA\ Unassigned\ Internet\ Protocol\ Number\ 252",
    "Univision.com",
    "Unknown\ virtual\ protocol",
    "UOL.com.br",
    "Upload.cnet.com",
    "uploaded.net",
    "Uploading.com",
    "uploadingit.com",
    "Usabit\ Bittorrent\ tracker",
    "USAToday.com",
    "Usejump.com",
    "UStream",
    "UTI",
    "uTorrent",
    "uTP\ (Micro\ Transport\ Protocol)",
    "UUSee\ Protocol",
    "V5.2-User\ Adaptation\ Layer",
    "Vakaka.com",
    "VampireFreaks.com",
    "Vanguardngr.com",
    "Varzesh3.com",
    "VBOX7.com",
    "Vecer",
    "Vecernji",
    "Vector\ Bittorrent\ tracker",
    "Veetle.com",
    "VeohTV",
    "Vetogate",
    "VEVO.com",
    "Vg.no",
    "Viadeo.com",
    "Viber",
    "VideoBash.com",
    "Videoplaza",
    "VideoSurf.com",
    "VideosZ",
    "VietBao.vn",
    "Viewpath",
    "Viewster",
    "Vijesti.me",
    "Vimeo.com",
    "Vine",
    "Vines\ Banyan\ Systems",
    "VISA",
    "VisAdd",
    "Visir.is",
    "Vivanews.com",
    "Van\ Jacobson\ Compressed",
    "Van\ Jacobson\ Uncompressed",
    "Vk.com\ (Vkontakte)",
    "VMTP",
    "VMWare",
    "vmware_horizon_view",
    "VnExpress.net",
    "Voddler.com",
    "Vox.com",
    "vpnoverdns",
    "Virtual\ Router\ Redundancy\ Protocol",
    "Vsee",
    "VTun\ (Virtual\ Tunnel)",
    "Vtunnel.com\ -\ Vtunnels.info",
    "Vube.com",
    "Vuiviet",
    "Vuze\ Bittorrent\ client",
    "Virtual\ Extensible\ Lan",
    "Vyew.com",
    "Wada",
    "Wakoopa.com",
    "Walla.co.il",
    "Wall\ Street\ Journal\ China\ (cn.wsj.com)",
    "Wandoujia",
    "Wasabi.com",
    "WahingtonPost.com",
    "Wat.tv",
    "Wattan",
    "Wayn.com",
    "Waze\ Social\ GPS\ Maps\ &\ Traffic",
    "WIDEBAND\ EXPAK",
    "WIDEBAND\ Monitoring",
    "Web\ Cache\ Communication\ Protocol",
    "Weather.com",
    "Weather2Umbrella.com",
    "Weather4all",
    "Web",
    "WebCrawler.com",
    "WebBiographies.com",
    "WebEx",
    "Webex\ WebOffice",
    "WebSocket",
    "Webtretho",
    "WeChat",
    "WeOurFamily.com",
    "Wer-Kennt-Wen.de",
    "Wrapped\ Encapsulating\ Security\ Payload",
    "Westpac.com.au",
    "Nintendo\ Wi-Fi\ Connection",
    "WhatsApp\ Messenger",
    "WHOIS",
    "WiiConnect24",
    "Wikia.com",
    "Wikipedia.com",
    "Willhaben.at",
    "Windows\ Azure\ CDN",
    "Windows\ Phone\ Marketplace",
    "Windows\ Update",
    "Windows\ Live",
    "Windows\ Live\ Spaces",
    "WindowsMedia.com",
    "Winmx",
    "winNY",
    "Windows\ Internet\ Naming\ Service",
    "WiserEarth",
    "Wixi.com",
    "WooriBank.com",
    "WordPress.com",
    "Worksite",
    "World\ of\ Warcraft",
    "Wp.pl",
    "Wretch.cc",
    "Wrike",
    "Wang\ Span\ Network",
    "World\ Series\ of\ Poker",
    "Wireless\ Session\ Protocol",
    "Wireless\ Transport\ layer\ Security",
    "Wireless\ Transaction\ Protocol",
    "X\ Window\ System",
    "X.25",
    "Xanga.com",
    "Xbox.com",
    "Xbox\ Live",
    "Xbox\ Live\ Marketplace",
    "Xcap",
    "X\ Display\ Manager\ Control\ Protocol",
    "Xendan",
    "X\ Font\ Server",
    "xHamster.com",
    "Xiami.com",
    "Xiaomi",
    "Xing.com",
    "Xinhuanet.com",
    "Xl",
    "XL\ Nonton",
    "XL\ wap",
    "XL\ Webmail",
    "XL.co.id",
    "XL.net.id",
    "SiriusXm.com",
    "XMLRPC",
    "Cross\ Net\ Debugger",
    "Xerox\ Network\ Systems",
    "XEROX\ NS\ IDP",
    "XNXX.com",
    "XOT\ (X25\ over\ TCP)",
    "XREA.com",
    "Xt3.com",
    "XTP",
    "Xuite.net",
    "Xvideos.com",
    "Xvideoslive.com",
    "XYPLEX",
    "Y8.com",
    "Yadro",
    "Yahoo.com",
    "Yahoo\ 360Plus\ Vietnam",
    "Yahoo\ Answers",
    "Yahoo\ Biz",
    "Yahoo\ Buy\ Taiwan",
    "Yahoo\ Douga",
    "Yahoo\ Games",
    "Yahoo\ Geocities",
    "Yahoo\ groups",
    "Yahoo\ Korea",
    "Yahoo\ Maps",
    "Yahoo\ Homes",
    "Yahoo\ Screen",
    "Yahoo\ Search",
    "Yahoo\ Stock",
    "Yahoo\ Travel",
    "Yam.com",
    "Yammer.com",
    "Yandex.ru",
    "Yandex\ webmail",
    "Yapo",
    "Yelp.com",
    "Yemen.net",
    "Yemennow",
    "Yesky.com",
    "Yield\ Manager",
    "Yihaodian.com",
    "Yle.fi",
    "Yahoo\ Mail\ v.2.0",
    "Yahoo\ Mail\ classic",
    "Yahoo\ webmail\ for\ mobile",
    "Yahoo\ webmail\ for\ mobile",
    "Yahoo\ Messenger",
    "Yahoo\ Messenger\ conference\ service",
    "Yahoo\ Messenger\ Transfer\ Protocol",
    "Yahoo\ Messenger\ Video",
    "Yahoo\ Webmessenger",
    "Ynet.co.il",
    "Yodiz",
    "Yoka.com",
    "Yomiuri.co.jp",
    "Yoono.com",
    "Youdao.com",
    "YouKu",
    "Youm7.com",
    "CalumBrannan.com",
    "Youni\ SMS",
    "Youporn.com",
    "YourFileHost.com",
    "yourfiles.biz",
    "YouSeeMore.com",
    "Hightail.com",
    "Youtube.com",
    "Youtube\ HD",
    "Yellow\ Page\ Bind",
    "Yellow\ Page\ Passwd",
    "Yellow\ Pages\ Server",
    "Yellow\ Pages\ Update",
    "Ytimg.com",
    "Yugma.com",
    "Yuugu.com",
    "Zabbix\ agent",
    "zalo",
    "Zaluu.com",
    "Zamunda.net",
    "Zattoo.com",
    "Zelune",
    "Zendesk",
    "Ziddu.com",
    "Zimbra.com",
    "Zimbra\ Webmail\ Standard\ Version",
    "Zing.vn",
    "Zoho\ Corporation",
    "Zoho\ CRM",
    "ZOHO\ DB\ and\ Reports",
    "Zoho\ Chat",
    "Zoho\ Meeting",
    "Zoho\ Notebook",
    "Zoho\ People",
    "Zoho\ Planner",
    "Zoho\ Share",
    "Zoho\ Sheet",
    "Zoho\ Show",
    "Zol.com.cn",
    "Zombie\ Tsunami",
    "ZoneAlarm\ Updates",
    "Zoo.gr",
    "Zougla",
    "Zoznam.sk",
    "zShare.com",
    "Zuji",
    "Zum.com",
    "Zumodrive",
    "Zynga.com",
]

def main():
    PACKETS = []
    #SET ALL DEFAULT VALUES
    RLENGTH = 1500

    parser = argparse.ArgumentParser()
    parser.add_argument("-i", "--interface", help="set replay interface", required=False,default='eth2' )
    parser.add_argument("-s", "--src", help="specify src ip", required=False, default=GenerateRandomIp())
    parser.add_argument("-d", "--dst", help="specify dst ip", required=False, default=GenerateRandomIp() )
    parser.add_argument("-S", "--sport", help="specify src port", required=False, default=RandomSafePortGenerator())
    parser.add_argument("-D", "--dport", help="specify dst port", required=False, default=RandomSafePortGenerator())
    parser.add_argument("-m", "--srcmac", help="specify src mac", required=False, default=GenerateRandomMac())
    parser.add_argument("-M", "--dstmac", help="specify dst mac", required=False, default=GenerateRandomMac())
    parser.add_argument("-X", "--method", help="specify method", required=False, default=1)
    parser.add_argument("-F", "--file", help="specify file to transfer", required=False, action='append', default = ['/opt/TrafficGen/TestFiles/Malicious_DOC.doc'])
    parser.add_argument("-t", "--type", help="specify type", required=False, default='IPv4')
    parser.add_argument("-q", "--clientseq", help="specify starting client SEQ", required=False, default = 1)
    parser.add_argument("-Q", "--serverseq", help="specify starting server SEQ", required=False, default = 1)
    parser.add_argument("-B", "--dstipv6", help="dst ipv6", required=False, default = None)
    parser.add_argument("-b", "--srcipv6", help="src ipv6", required=False, default = None)
    parser.add_argument("-A", "--setipv6", help="specify ipv6 transfer", required=False, default=False, action="store_true")
    parser.add_argument("-o", "--scapyoutput", help="specify output file", required=False, default=False)
    parser.add_argument("-x", "--pps", help="specify speed of replay in packets per second", required=False, default=None)
    parser.add_argument("-v","--vlanTag", help="specify vlan tag id", required=False, default=None)
    parser.add_argument("-N","--cn", help="commone name", required=False, default = "nathan_is_awesome")
    parser.add_argument("-I", "--issuer", help="issuer", required=False, default = 'nathan_is_the_best.com')
    parser.add_argument("-V", "--version", help="ssl version", required=False, default = 'TLS_1_0')

    args = parser.parse_args()
    HTTPS = HTTPS_support()
    for subject in NAMES:
        HTTPS.SetVariables(METHOD = "GET",
                           dmac = args.dstmac,
                           smac = args.srcmac,
                           TYPE= args.type,
                           src = args.src,
                           dst = args.dst,
                           sport = args.sport,
                           dport = 443,
                           INTF = args.interface,
                           FILES = args.file,
                           InitClientSeq=args.clientseq,
                           InitServerSeq=args.serverseq,
                           rlength = RLENGTH,
                           Verbose = args.pps,
                           vlanTag=args.vlanTag,
                           subject=subject,
                           issuer=args.issuer,
                           version=args.version,
                           )
        PACKETS += HTTPS.HTTPS_TEST()
        print 'len packets:', len(PACKETS)

    if args.scapyoutput:
        wrpcap(args.scapyoutput, PACKETS)
    else:
        sendp(PACKETS,iface=args.interface)

if __name__ == "__main__":
    main()